﻿var Layout = {}

Layout._height = null;

/// <summary>Initialize the layout view.</summary>
Layout.init = function () {
    // Initialize the main splitter.
    $("#mainSplitter").kendoSplitter({
        orientation: "vertical",
        panes: [
            { size: "104px", resizable: false }
        ]
    });

    $("#mainMenu").kendoMenu({
        dataSource: [{
            text: "Home",
            url: "http://www.telerikmvpsamples.com"
        }]
    });

    // Initialize the content splitter.
    $("#contentSplitter").kendoSplitter({
        panes: [
            { contentUrl: _rootUrl + "Home/Navigation", size: "200px", collapsible: true }
        ]
    });

    // Hide th e scrollbar in the main splitter.
    $('#mainSplitter').children('div.k-pane').css('overflow-y', 'hidden');

    // Call the Layout.resize function every 100 miliseconds.
    setInterval("Layout.resize()", 100);
}

/// <summary>Check the size of the window, and if it has changed, then resize the splitters to fit the window.</summary>
Layout.resize = function () {
    var height = $(window).height();

    // Has the window height changed?
    if (height != Layout._height) {
        Layout._height = height;

        // Resize the main splitter.
        var mainSplitter = $('#mainSplitter');
        mainSplitter.height(height - 25);
        mainSplitter.resize();

        // Resize the content splitter.
        var contentSplitter = $('#contentSplitter');
        contentSplitter.height(height - 77);
        contentSplitter.resize();
    }
}


Layout.Navigation = {}

Layout.Navigation.init = function () {
    $("#navPanelBar").kendoPanelBar({
        expandMode: "single",
        select: Layout.Navigation.navPanelBar_onSelect
    });
}

Layout.Navigation.navPanelBar_onSelect = function (e) {
    if ($(e.item).hasClass("tm-sprint")) {
        var splitter = $("#contentSplitter").data("kendoSplitter");
        splitter.ajaxRequest("#contentPane", _rootUrl + "Home/Sprint/", { id: $(e.item).attr("id") });
    } else if ($(e.item).hasClass("tm-developer")) {
        var splitter = $("#contentSplitter").data("kendoSplitter");
        splitter.ajaxRequest("#contentPane", _rootUrl + "Home/Developer/", { id: $(e.item).attr("id") });
    }
}

Layout.Navigation.syncNavPanelBar = function (funcptr) {
    var splitter = $("#contentSplitter").data("kendoSplitter");

    if (funcptr != undefined) {
        splitter.bind("contentLoad", funcptr);
    }
    splitter.ajaxRequest("#navigationPane", _rootUrl + "Home/Navigation");
}

Layout.Navigation.expandDeveloperItem = function (e) {
    var splitter = $("#contentSplitter").data("kendoSplitter");
    var panelBar = $("#navPanelBar").data("kendoPanelBar");
    panelBar.expand(panelBar.element.find("li.tm-developer-pane"));
    splitter.unbind("contentLoad", Layout.Navigation.expandDeveloperItem);
}