﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel;
using TaskManager.Data;
using System.Web.Script.Serialization;

using Microsoft.Practices.Unity;
using Microsoft.Practices.Unity.Configuration;

namespace TaskManager
{
    public partial class Developer
    {
        public string Name { get { return string.Format("{0} {1}", this.FirstName, this.LastName); } }

        public IList<Task> GetTasks()
        {
            IList<Task> tasks = null;

            using (IUnityContainer container = new UnityContainer())
            {
                container.LoadConfiguration();
                ISprintRepository sprintRepository = container.Resolve<ISprintRepository>();
                tasks = sprintRepository.GetTasks(this);
            }
            return tasks;
        }

        public void Copy(Developer src)
        {
            this.FirstName = src.FirstName;
            this.LastName = src.LastName;
            this.Title = src.Title;
        }
    }
}